<?php
declare(strict_types=1);

namespace FiloBlu\Core\Model;

use FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface;
use FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterfaceFactory;
use Magento\Framework\Api\DataObjectHelper;

class FbOrderExtensionAttr extends \Magento\Framework\Model\AbstractModel
{

    protected $_eventPrefix = 'fb_extensionattributes_order';
    protected $fborderextensionattrDataFactory;

    protected $dataObjectHelper;


    /**
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param FbOrderExtensionAttrInterfaceFactory $fborderextensionattrDataFactory
     * @param DataObjectHelper $dataObjectHelper
     * @param \FiloBlu\Core\Model\ResourceModel\FbOrderExtensionAttr $resource
     * @param \FiloBlu\Core\Model\ResourceModel\FbOrderExtensionAttr\Collection $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        FbOrderExtensionAttrInterfaceFactory $fborderextensionattrDataFactory,
        DataObjectHelper $dataObjectHelper,
        \FiloBlu\Core\Model\ResourceModel\FbOrderExtensionAttr $resource,
        \FiloBlu\Core\Model\ResourceModel\FbOrderExtensionAttr\Collection $resourceCollection,
        array $data = []
    ) {
        $this->fborderextensionattrDataFactory = $fborderextensionattrDataFactory;
        $this->dataObjectHelper = $dataObjectHelper;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Retrieve fborderextensionattr model with fborderextensionattr data
     * @return FbOrderExtensionAttrInterface
     */
    public function getDataModel()
    {
        $fborderextensionattrData = $this->getData();

        $fborderextensionattrDataObject = $this->fborderextensionattrDataFactory->create();
        $this->dataObjectHelper->populateWithArray(
            $fborderextensionattrDataObject,
            $fborderextensionattrData,
            FbOrderExtensionAttrInterface::class
        );

        return $fborderextensionattrDataObject;
    }
}

